%include 'config.inc'

segment .text
use16

global wait_packet
wait_packet:
	pusha
.1:	mov	dx, BASE_ADDR+7
	;no error check
	in	al, dx
	test	al, 1
	jz	.1
	popa
	ret

global send_ack
send_ack:
	pusha
	;cx contains # of bytes to copy from RAM to ne2000 (rounded up)
.start:	mov	cx, 44
	mov	si, udp_ack_packet
	;set remote dma BASE address
	xor	al, al
	mov	dx, BASE_ADDR+8
	out	dx, al
	inc	dx
	mov	al, 40h
	out	dx, al
	inc	dx
	;count bytes
	mov	al, cl
	out	dx, al
	inc	dx
	mov	al, ch
	out	dx, al
	;start dma
	mov	dx, BASE_ADDR
	mov	al, 00010010b
	out	dx, al
	shr	cx, 1
	;dma
	add	dx, 10h
	rep outsw
	;ack dma
	mov	dx, BASE_ADDR+7
	mov	al, 01000000b
	out	dx, al
	;send command
	;set tpsr: transmit page start register
	mov	al, 40h
	mov	dx, BASE_ADDR+4
	out	dx, al
	;set tbcr: transmit byte count register
	;(we must(?) send at least 64 bytes)
	inc	dx
	mov	al, 64
	out	dx, al
	inc	dx
	xor	al, al
	out	dx, al
	;start the send
	mov	al, 00100110b
	mov	dx, BASE_ADDR
	out	dx, al
	;wait for sent done
	mov	dx, BASE_ADDR+7
.1:	in	al, dx
	;error? (not sure about this code)
	test	al, 8
	jz	.2
	;clear error and start over
	and	al, 8+2
	out	dx, al
	jmp	.start
.2:	and	al, 2
	jz	.1
	;ack it
	out	dx, al
	popa
	ret

;return ZF if last packet
global get_packet
get_packet:
	pusha
.more:  ;get size of packet
        ;set dma addr
        mov    dx, BASE_ADDR+8
        xor    ax, ax
        out    dx, al
        inc    dx
        mov    al, [curr_read]
        out    dx, al
        ;count=4
        mov    dx, BASE_ADDR+0ah
        mov    al, 4
        out    dx, al
        inc    dx
        xor    ax, ax
        out    dx, al
        ;start read command
        mov    dx, BASE_ADDR
        mov    al, 00001010b
        out    dx, al
        ;read it
        mov    dx, BASE_ADDR+10h
        in     ax, dx
        mov    bx, ax
        in     ax, dx
        ;ack dma ! Fuck, I lost something like 5 hours on this shit !
        mov    cx, ax
        mov    dx, BASE_ADDR+7
        mov    al, 40h
        out    dx, al
	;size is in cx
	;printreg cl
	;printreg ch
	;printreg bl
	;printreg bh
	mov	word [buffer_size], cx
        ;read it now !
        ;set dma addr
        mov    dx, BASE_ADDR+8
        mov    al, 4
        out    dx, al
        inc    dx
        mov    al, [curr_read]
        out    dx, al
        ;count=cx
        mov    dx, BASE_ADDR+0ah
        mov    al, cl
        out    dx, al
        inc    dx
        mov    al, ch
        out    dx, al
        ;start read command
        mov    dx, BASE_ADDR
        mov    al, 00001010b
        out    dx, al
        ;read it
	mov	di, buffer
        mov    dx, BASE_ADDR+10h
        shr    cx, 1
        jnc    .1
        insw
.1:     rep insw
        ;ack dma
        mov    dx, BASE_ADDR+7
        mov    al, 40h
        out    dx, al
        mov    al, bh
        mov    [curr_read], al
        dec    al
        cmp    al, 40h+12-1
        jne    .2
        mov    al, 80h-1
.2:     mov    dx, BASE_ADDR+3
        out    dx, al
        ;ack the int
        mov    dx, BASE_ADDR+7
        mov    al, bl
        out    dx, al
        ;packet has been received or fucked out
        ;now let's see if there is no more packet to read
        mov    dx, BASE_ADDR
        mov    al, 60h
        out    dx, al
        mov    dx, BASE_ADDR+7
        in     al, dx
        mov    bl, al
        mov    dx, BASE_ADDR
        mov    al, 20h
        out    dx, al
	;println "p in"
	;mov	si, buffer
	;mov	cx, [buffer_size]
	;printreg cl
	;printreg ch
.p:	;lodsb
	;call	putx
	;loop	.p
	;println "ep"
	;mov	byte [putx_count], 0
        cmp    bl, [curr_read]
	jz	.done
	;receiving more than 1 packet before sending a ack is an error
	;let's loop forever
.err:	jmp	.err
	;jmp	.more
.done:  popa
	;we can only receive UDP packet with payload of 1 byte or 1024 bytes
	;to know if last packet, simply check the upper 8 bits of its length
	cmp	byte [buffer_size+1], 0
	ret

global reset_card
reset_card:
	pusha
	mov	dx, BASE_ADDR+1fh
	in	al, dx
	out	dx, al
	;mov	al, 0
.1:	;printreg al
	;push	ax
	mov	ah, 86h
	mov	cx, 1000000 / 65536
	mov	dx, 1000000 % 65536
	int	15h
	;pop	ax
	;inc	al
	;jmp	.1
	mov	dx, BASE_ADDR
	mov	al, 21h
	out	dx, al
	mov	dx, BASE_ADDR+7
.2:	in	al, dx
	test	al, 80h
	jz	.2
	popa
	ret

global open_card
open_card:
	pusha
	mov	si, opencard_data
	xor	ax, ax
.2:	lodsb
	dec	ax
	js	.1
	mov	dx, BASE_ADDR
	add	dx, ax
	lodsb
	out	dx, al
	jmp .2
.1:	popa
	ret

segment .data
opencard_data:
;table structure:
;    byte 0: offset from BASE_ADDR + 1 (1 means BASE_ADDR)
;    byte 1: value to out
;mov al,21h                   ;stop mode
;mov dx,COMMAND
;out dx,a1
	db 1
	db 21h
;mov a1,dcr
;mov dx,DATACONFIGURATION     ;data configuration register
;out dx,a1
	db 1 + 0eh
	db 49h                   ;58h
;mov dx,REMOTEBYTECOUNT0
;xor a1,a1
;out dx,a1                    ;low remote byte count
	db 1 + 0ah
	db 0
;mov dx,REMOTEBYTECOUNT1
;out dx,a1                    ;high remote byte count
	db 1 + 0bh
	db 0
;mov a1,rcr
;mov dx,RECEIVECONFIGURATION  ;receive configuration register
;out dx,a1
	db 1 + 0ch
	db 00011110b              ;0
;mov a1,20h
;mov dx,TRANSMITPAGE          ;transmit page start
;out dx,a1
	db 1 + 04h
	db 40h        ;20h
;mov a1,02
;mov dx,TRANSMITCONFIGURATION
;out dx,a1                    ;temporarily go into Loopback mode
	db 1 + 0dh
	db 02h
;mov a1,26h
;mov dx,PAGESTART             ;page start
;out dx,a1
	db 1 + 01h
	db 40h + 12    ;26h
;mov dx,BOUNDARY              ;boundary register
;out dx,a1
	db 1 + 03h
	db 40h + 12      ;26h
;mov a1,40h
;mov dx,PAGESTOP              ;page stop
;out dx,a1
	db 1 + 02h
	db 80h        ;40h
;mov a1,61h                   ;go to page 1 registers
;mov dx,COMMAND
;out dx,a1
	db 1
	db 61h
;mov a1,26h
;mov dx,CURRENT               ;current page register
;out dx,a1
	db 1 + 07h
	db 40h + 12 + 1   ;26h
;mov a1,22h                   ;back to page 0, start mode
;mov dx,COMMAND
;out dx,a1
	db 1
	db 22h
;mov a1,0ffh
;mov dx,INTERRUPTSTATUS       ;interrupt status register
;out dx,a1
	db 1 + 07h
	db 0ffh
;mov a1,imr
;mov dx,INTERRUPTMASK         ;interrupt mask register
;out dx,a1
	db 1 + 0fh
	db 0h
;mov dx,TRANSMITCONFIGURATION
;mov a1,tcr
;out dx,a1                    ;TCR in norma1 mode, NIC is now
;                             ;ready for reception
	db 1 + 0dh
	db 0h
	; end of list
	db 0

segment .data
curr_read db 40h+12+1

segment .bss
buffer_size	resw 1
global buffer
buffer		resb 1800

;UDP ack packet
;ethernet:
;ff ff ff ff ff ff  <dest>
;1  2  3  4  5  6   <src>
;08 00              <ethertype>
;ip:
;45 00  <version> <ihl> <dscp> <ecn>
;00 1d  <total length (of ip data)>
;00 00  <identification>
;40 00  <flags> <fragment offset>
;40 11  <ttl> <protocol>
;78 c4  <checksum>
;c0 a8 01 64  <source ip>
;ff ff ff ff  <dest ip>
;udp:
;1 1     <src port>
;66 66   <dst port>
;0  9    <len>
;0 0     <checksum (0 means no checksum)>
;0       <data>
segment .data
udp_ack_packet: ;total length is 43
db 0xff, 0xff, 0xff, 0xff, 0xff, 0xff  ;<dest>
db 1,  2,  3,  4,  5,  6   ;<src>
db 08, 00              ;<ethertype>
;ip:
db 0x45, 00  ;<version> <ihl> <dscp> <ecn>
db 00, 0x1d  ;<total length (of ip data)>
db 00, 00  ;<identification>
db 0x40, 00  ;<flags> <fragment offset>
db 0x40, 0x11  ;<ttl> <protocol>
db 0x78, 0xc4  ;<checksum>
db 0xc0, 0xa8, 0x01, 0x64  ;<source ip>
db 0xff, 0xff, 0xff, 0xff  ;<dest ip>
;udp:
db 1, 1     ;<src port>
db 0x66, 0x66   ;<dst port>
db 0,  9    ;<len>
db 0, 0     ;<checksum (0 means no checksum)>
db 0x2       ;<data> 2 = gimme stage2 bootloader please
