%include 'stdio.inc'
%include 'card.inc'
%include 'net.inc'
%include 'linux.inc'

segment .text
use16

global _start
_start:
	mov	ax, cs
	mov	ds, ax
	mov	ax, 1000h
	mov	es, ax
	xor	ax, ax
	mov	sp, ax
	cld
	println "OK"
	println "stage 2"
	call	open_card
	;let's get the first 2 blocks of the kernel (first network packet)
	call	send_ack
	call	wait_packet
	call	get_packet
	;move it to 1000h:0000h, where we load the kernel 16b code
	xor	di, di
	mov	cx, 1024
	;start of data in received udp packet, hardcoded to 42
	mov	si, buffer+42
	rep movsb

	;setup stuff for the linux startup 16bits code
	;see Documentation/x86/boot.txt

	;first of all, let's read all the setup code
	mov	al, [es:setup_sects]
	or	al, al
	jnz	.1
	mov	al, 4
.1:	println "number of 512 blocks for the setup kernel code"
	printreg al
	xor	cx, cx
	mov	cl, al
	;we already loaded the 1st block
	dec	cx
.2:	call	next_block
	loop	.2

	;check recent kernel
	mov	ax, [es:202h]
	cmp	ax, 6448h
	jnz	.bad
	mov	ax, [es:204h]
	cmp	ax, 5372h
	jnz	.bad

	;check protocol version
	mov	ax, [es:version]
	cmp	ax, 020ah
	jnz	.bad

	mov	byte [es:type_of_loader], 0ffh

	mov	al, [es:loadflags]
	or	al, 1
	jz	.bad

	mov	ax, 0xe000-0x0200
	mov	[es:heap_end_ptr], ax
	or	byte [es:loadflags], 0x80

	mov	ax, cmdline
	mov	[es:cmd_line_ptr], ax
	xor	ax, ax
	mov	[es:cmd_line_ptr+2], ax

	;gdt is (this is for 286, the doc I have here):
	;(on 386, the 'res' field is used to map to all 4GiB address space)
	;(check intel documentation)
	;struct seg_desc {
	;0:  int16 length
	;2:  int16 low_addr
	;4:  int8  high_addr
	;5:  int8  attr
	;6:  int16 res
	;}
	;
	;struct gdt {
	;  struct seg_desc dummy
	;  struct seg_desc gdts(?)
	;  struct seg_desc src
	;  struct seg_desc dst
	;  struct seg_desc code
	;  struct seg_desc stack
	;}
	;
	;setup a gdt at 0x7c00 (only src and dst must be set)
	mov	ax, cs
	mov	es, ax
	mov	di, 0x7c00
	mov	cx, 8*6
	xor	al, al
	rep stosb

	;init src and dst
	mov	bp, 0x7c00
	mov	word [bp+2*8 + 0], 512		;src.length = 512
	mov	word [bp+2*8 + 2], 0x8000	;src.low_addr = 0x8000
	mov	word [bp+2*8 + 5], 0x92		;src.attr = 0x92
	mov	word [bp+3*8 + 0], 512		;dst.length = 512
	mov	byte [bp+3*8 + 4], 0x10		;dst.high_addr = 0x10
	mov	byte [bp+3*8 + 5], 0x92		;dst.attr = 0x92

;println "dest addr before:"
;mov ax, [bp+3*8+2]
;printreg al
;printreg ah
;mov al, [bp+3*8+4]
;printreg al

	;load kernel to high memory
.3:	mov	di, 8000h
	pusha
	mov	ax, '+' + 0e00h
	int	10h
	popa
	call	next_block
	jc	.5
;mov al, [8000h]
;printreg al
;mov al, [8100h]
;printreg al
;pusha
;mov ah, 0
;int 16h
;popa
	pusha
	mov	ah, 0x87
pusha
mov	si, bp
mov	di, bp
add	di, 0x100
mov	cx, 8*6
rep movsb
popa
	mov	si, bp
add si, 0x100
	mov	cx, 512/2
	int	15h
	or	ah, ah
	jz	.4
	;jnc	.4
	println "int 15 error"
	printreg al
	printreg ah
	jmp	.eof
.4:	popa
;println "dest addr after:"
;mov ax, [bp+3*8+2]
;printreg al
;printreg ah
;mov al, [bp+3*8+4]
;printreg al
	add	word [bp+3*8 + 2], 512
	adc	byte [bp+3*8 + 4], 0
;println "one block done"
;mov al, [8000h]
;printreg al
;inc byte [fuckme]
;cmp byte [fuckme], 3
;jz .5
	jmp	.3
.5:	println "done, booting linux"

;println "before:"
;mov al, [0x8000]
;printreg al
;	mov	word [bp+2*8 + 0], 512		;src.length = 512
;	mov	word [bp+2*8 + 2], 0
;	mov	word [bp+2*8 + 4], 0x10
;	mov	word [bp+2*8 + 5], 0x92		;src.attr = 0x92
;	mov	word [bp+3*8 + 0], 512		;dst.length = 512
;	mov	word [bp+3*8 + 2], 0x8000
;	mov	byte [bp+3*8 + 4], 0
;	mov	byte [bp+3*8 + 5], 0x92		;dst.attr = 0x92
;	mov	si, bp
;	mov	cx, 512/2
;	mov	ah, 0x87
;	int	15h
;	or	ah, ah
;	jz	.xx
;	;jnc	.4
;	println "int 15 error"
;	printreg al
;	printreg ah
;	jmp	.eof
;.xx:println "ok?"
;mov al, [0x8000]
;printreg al
;mov ax, ds
;printreg al
;printreg ah

;.0:jmp .0

	;stop floppy
        ;BIOS reset
	xor	ah, ah
	xor	dl, dl
	int	13h
	;stop motor
	mov	dx, 3f2h
	in	al, dx
	and	al, 0fh
	out	dx, al

	;all done, jump to kernel
	mov	ax, 1000h
	mov	es, ax
	mov	ss, ax
	mov	ds, ax
		mov	fs, ax
		mov	gs, ax
	mov	ax, 0xe000
	mov	sp, ax
	xor	ax, ax
	xor	bx, bx
	xor	cx, cx
	xor	dx, dx
	xor	si, si
	xor	di, di
	xor	bp, bp
	push	word 0
	popf
	cli
	jmp 1020h:0h

.bad:	println "bad kernel version, can't load"
.eof:	jmp	.eof

segment .data
cmdline db "auto", 0
;fuckme db 0
