%include 'card.inc'

segment .text
use16

;returns next block, gets a packet from the network if has to
;a packet is 1024 bytes, a block is 512
;input: es:di pointer to next block location
;output: di points to next block
;CF if no more packet (don't call the function again after that point!)
;no other register modified
global next_block
next_block:
	push	si
	push	cx
	cmp	byte [block_count], 0
	jnz	.1
	;block_count = 0, get next packet
	call	send_ack
	call	wait_packet
	call	get_packet
	jnz	.0
	pop	cx
	pop	si
	stc
	ret
.0:	mov	byte [block_count], 2
.1:	mov	si, buffer+42
	mov	cx, 512
	cmp	byte [block_count], 2
	jz	.2
	add	si, cx
.2:	rep movsb
	dec	byte [block_count]
	pop	cx
	pop	si
	clc
	ret

section .data
block_count db 0
