;%include 'stdio.inc'
;%include 'card.inc'
;%include 'net.inc'
%include 'linux.inc'
%include 'config.inc'

buffer_size	equ 0x8600+2
buffer		equ 0x8600+4

segment .text
use16

global _start
_start:
	;mov	ax, cs
	;mov	ds, ax
	push	1000h
	pop	es
	xor	sp, sp
	cld
	;open_card begin
	mov	si, opencard_data
	call	do_outs
	;open_card end
	xor	di, di
	call	next_block
	call	next_block

	;setup stuff for the linux startup 16bits code
	;see Documentation/x86/boot.txt

	;first of all, let's read all the setup code
	;xor	cx, cx
	;mov	cl, [es:setup_sects]
	movzx	cx, byte [es:setup_sects]
	;we already loaded the 1st block
	dec	cx
.2:	call	next_block
	loop	.2

	mov	byte [es:type_of_loader], 0ffh

	mov	ax, 0xe000-0x0200
	mov	[es:heap_end_ptr], ax
	or	byte [es:loadflags], 0x80

	mov	ax, cmdline
	mov	[es:cmd_line_ptr], ax
	xor	ax, ax
	;mov	[es:cmd_line_ptr+2], ax

	;gdt is (this is for 286, the doc I have here):
	;(on 386, the 'res' field is used to map to all 4GiB address space)
	;(check intel documentation)
	;struct seg_desc {
	;0:  int16 length
	;2:  int16 low_addr
	;4:  int8  high_addr
	;5:  int8  attr
	;6:  int16 res
	;}
	;
	;struct gdt {
	;  struct seg_desc dummy
	;  struct seg_desc gdts(?)
	;  struct seg_desc src
	;  struct seg_desc dst
	;  struct seg_desc code
	;  struct seg_desc stack
	;}
	;
	;setup a gdt at 0x7e00 (only src and dst must be set)
	push	cs
	pop	es
	mov	di, 0x7e00
	mov	cl, 8*6
	;xor	al, al
	;at this point ax=0, if you change something, take care
	rep stosb

	;init src and dst
	mov	bp, 0x7e00
	mov	word [bp+2*8 + 0], 512		;src.length = 512
	mov	word [bp+2*8 + 2], 0x8000	;src.low_addr = 0x8000
	mov	word [bp+2*8 + 5], 0x92		;src.attr = 0x92
	mov	word [bp+3*8 + 0], 512		;dst.length = 512
	mov	byte [bp+3*8 + 4], 0x10		;dst.high_addr = 0x10
	mov	byte [bp+3*8 + 5], 0x92		;dst.attr = 0x92

	;load kernel to high memory
.3:	mov	di, 8000h
	call	next_block
	jc	.5
	pusha
	mov	ah, 0x87
	mov	si, bp
	mov	cx, 512/2
	int	15h
	or	ah, ah
	jnz	.eof
	popa
	add	word [bp+3*8 + 2], 512
	adc	byte [bp+3*8 + 4], 0
	jmp	.3
.5:
	;stop floppy
        ;BIOS reset
	xor	ah, ah
	xor	dl, dl
	int	13h
	;stop motor
	mov	dx, 3f2h
	in	al, dx
	and	al, 0fh
	out	dx, al

	;all done, jump to kernel
	mov	ax, 1000h
	mov	es, ax
	mov	ss, ax
	mov	ds, ax
	mov	sp, 0xe000
	cli
	jmp 1020h:0h

.bad:	;println "bad kernel version, can't load"
.eof:	jmp	.eof

;segment .data
cmdline db "auto", 0
;%include 'config.inc'
;%include 'stdio.inc'

segment .text
use16

;wait_packet:
;	pusha
;.1:	mov	dx, BASE_ADDR+7
;	;no error check
;	in	al, dx
;	test	al, 1
;	jz	.1
;	popa
;	ret

;send_ack:
;	pusha
;	;cx contains # of bytes to copy from RAM to ne2000 (rounded up)
;.start:	mov	cx, 44
;	mov	si, udp_ack_packet
;	;set remote dma BASE address
;	xor	al, al
;	mov	dx, BASE_ADDR+8
;	out	dx, al
;	inc	dx
;	mov	al, 40h
;	out	dx, al
;	inc	dx
;	;count bytes
;	mov	al, cl
;	out	dx, al
;	inc	dx
;	mov	al, ch
;	out	dx, al
;	;start dma
;	mov	dx, BASE_ADDR
;	mov	al, 00010010b
;	out	dx, al
;	shr	cx, 1
;	;dma
;	add	dx, 10h
;	rep outsw
;	;ack dma
;	mov	dx, BASE_ADDR+7
;	mov	al, 01000000b
;	out	dx, al
;	;send command
;	;set tpsr: transmit page start register
;	mov	al, 40h
;	mov	dx, BASE_ADDR+4
;	out	dx, al
;	;set tbcr: transmit byte count register
;	;(we must(?) send at least 64 bytes)
;	inc	dx
;	mov	al, 64
;	out	dx, al
;	inc	dx
;	xor	al, al
;	out	dx, al
;	;start the send
;	mov	al, 00100110b
;	mov	dx, BASE_ADDR
;	out	dx, al
;	;wait for sent done
;	mov	dx, BASE_ADDR+7
;.1:	in	al, dx
;	;error? (not sure about this code)
;	test	al, 8
;	jz	.2
;	;clear error and start over
;	and	al, 8+2
;	out	dx, al
;	jmp	.start
;.2:	and	al, 2
;	jz	.1
;	;ack it
;	out	dx, al
;	popa
;	ret

get_packet_data:
	db 1+8
	db 0
	db 1+9
curr_read:
	db 40h+12+1
	db 1+0ah
	db 1600&0xff
	db 1+0bh
	db 1600>>8
	db 1
	db 00001010b
	db 0

;return ZF if last packet
;get_packet:
;	pusha
;	mov	si, get_packet_data
;	call	do_outs
;;        ;set dma addr
;;        mov    dx, BASE_ADDR+8
;;        xor    ax, ax
;;        out    dx, al
;;        inc    dx
;;        mov    al, [curr_read]  ;40h+12+1
;;        out    dx, al
;;        ;count=1600
;;	mov    cx, 1600
;;        mov    dx, BASE_ADDR+0ah
;;        mov    al, cl
;;        out    dx, al
;;        inc    dx
;;	mov    al, ch
;;        out    dx, al
;;        ;start read command
;;        mov    dx, BASE_ADDR
;;        mov    al, 00001010b
;;        out    dx, al
;        ;read it
;	push	es
;	push	ds
;	pop	es
;	mov	di, buffer-4
;        mov    dx, BASE_ADDR+10h
;	mov	cx, 1600/2
;        rep insw
;	pop	es
;        ;ack dma
;        mov    dx, BASE_ADDR+7
;        mov    al, 40h
;        out    dx, al
;	mov	al, [buffer-4+1]
;	mov	[curr_read], al
;        dec    al
;        cmp    al, 40h+12-1
;        jne    .2
;        mov    al, 80h-1
;.2:     mov    dx, BASE_ADDR+3
;        out    dx, al
;        ;ack the int
;        mov    dx, BASE_ADDR+7
;        mov    al, [buffer-4]
;        out    dx, al
;        popa
;	;we can only receive UDP packet with payload of 1 byte or 1024 bytes
;	;to know if last packet, simply check the upper 8 bits of its length
;	cmp	byte [buffer_size+1], 0
;	ret

;waits in ds:si the list of out to do
do_outs:
	xor	ax, ax
.2:	lodsb
	dec	ax
	js	.1
	mov	dx, BASE_ADDR
	add	dx, ax
	lodsb
	out	dx, al
	jmp .2
.1:	ret

;segment .data
opencard_data:
;table structure:
;    byte 0: offset from BASE_ADDR + 1 (1 means BASE_ADDR)
;    byte 1: value to out
;mov al,21h                   ;stop mode
;mov dx,COMMAND
;out dx,a1
	db 1
	db 21h
;mov a1,dcr
;mov dx,DATACONFIGURATION     ;data configuration register
;out dx,a1
	db 1 + 0eh
	db 49h                   ;58h
;mov dx,REMOTEBYTECOUNT0
;xor a1,a1
;out dx,a1                    ;low remote byte count
	db 1 + 0ah
	db 0
;mov dx,REMOTEBYTECOUNT1
;out dx,a1                    ;high remote byte count
	db 1 + 0bh
	db 0
;mov a1,rcr
;mov dx,RECEIVECONFIGURATION  ;receive configuration register
;out dx,a1
	db 1 + 0ch
	db 00011110b              ;0
;mov a1,20h
;mov dx,TRANSMITPAGE          ;transmit page start
;out dx,a1
	db 1 + 04h
	db 40h        ;20h
;mov a1,02
;mov dx,TRANSMITCONFIGURATION
;out dx,a1                    ;temporarily go into Loopback mode
	db 1 + 0dh
	db 02h
;mov a1,26h
;mov dx,PAGESTART             ;page start
;out dx,a1
	db 1 + 01h
	db 40h + 12    ;26h
;mov dx,BOUNDARY              ;boundary register
;out dx,a1
	db 1 + 03h
	db 40h + 12      ;26h
;mov a1,40h
;mov dx,PAGESTOP              ;page stop
;out dx,a1
	db 1 + 02h
	db 80h        ;40h
;mov a1,61h                   ;go to page 1 registers
;mov dx,COMMAND
;out dx,a1
	db 1
	db 61h
;mov a1,26h
;mov dx,CURRENT               ;current page register
;out dx,a1
	db 1 + 07h
	db 40h + 12 + 1   ;26h
;mov a1,22h                   ;back to page 0, start mode
;mov dx,COMMAND
;out dx,a1
	db 1
	db 22h
;mov a1,0ffh
;mov dx,INTERRUPTSTATUS       ;interrupt status register
;out dx,a1
	db 1 + 07h
	db 0ffh
;mov a1,imr
;mov dx,INTERRUPTMASK         ;interrupt mask register
;out dx,a1
	db 1 + 0fh
	db 0h
;mov dx,TRANSMITCONFIGURATION
;mov a1,tcr
;out dx,a1                    ;TCR in norma1 mode, NIC is now
;                             ;ready for reception
	db 1 + 0dh
	db 0h
	; end of list
	db 0

;segment .data
;curr_read db 40h+12+1

;UDP ack packet
;ethernet:
;ff ff ff ff ff ff  <dest>
;1  2  3  4  5  6   <src>
;08 00              <ethertype>
;ip:
;45 00  <version> <ihl> <dscp> <ecn>
;00 1d  <total length (of ip data)>
;00 00  <identification>
;40 00  <flags> <fragment offset>
;40 11  <ttl> <protocol>
;78 c4  <checksum>
;c0 a8 01 64  <source ip>
;ff ff ff ff  <dest ip>
;udp:
;1 1     <src port>
;66 66   <dst port>
;0  9    <len>
;0 0     <checksum (0 means no checksum)>
;0       <data>
;segment .data
udp_ack_packet: ;total length is 43
;ethernet:
db 0xff, 0xff, 0xff, 0xff, 0xff, 0xff  ;<dest>
db 1,  2,  3,  4,  5,  6   ;<src>
db 08, 00              ;<ethertype>
;ip:
db 0x45, 00  ;<version> <ihl> <dscp> <ecn>
db 00, 0x1d  ;<total length (of ip data)>
db 00, 00  ;<identification>
db 0x40, 00  ;<flags> <fragment offset>
db 0x40, 0x11  ;<ttl> <protocol>
db 0x78, 0xc4  ;<checksum>
db 0xc0, 0xa8, 0x01, 0x64  ;<source ip>
db 0xff, 0xff, 0xff, 0xff  ;<dest ip>
;udp:
db 1, 1     ;<src port>
db 0x66, 0x66   ;<dst port>
db 0,  9    ;<len>
db 0, 0     ;<checksum (0 means no checksum)>
db 0x17       ;<data> 17 = gimme kernel please
;%include 'card.inc'

segment .text
use16

send_ack_data:
	db 1+8
	db 0
	db 1+9
	db 40h
	db 1+0ah
	db 44
	db 1+0bh
	db 0
	db 1
	db 00010010b
	db 0

send_ack_after_data:
	db 1+7
	db 01000000b
	db 1+4
	db 40h
	db 1+5
	db 64
	db 1+6
	db 0
	db 1
	db 00100110b
	db 0

;returns next block, gets a packet from the network if has to
;a packet is 1024 bytes, a block is 512
;input: es:di pointer to next block location
;output: di points to next block
;CF if no more packet (don't call the function again after that point!)
;no other register modified
next_block:
	;push	si
	push	cx
	mov	si, buffer+42+512
	mov	cx, 512
	dec	byte [block_count]
	jns	.2
	;block_count < 0, get next packet
	mov	byte [block_count], 1
	sub	si, cx
	;call	send_ack
	;send_ack begin
	pusha
.sa.start:
	mov	si, send_ack_data
	call	do_outs
	mov	si, udp_ack_packet
	;dma
	mov	cx, 22
	add	dx, 10h
	rep outsw
	mov	si, send_ack_after_data
	call	do_outs
	;wait for sent done
	mov	dx, BASE_ADDR+7
.sa.1:	in	al, dx
	;error? (not sure about this code)
	test	al, 8
	jz	.sa.2
	;clear error and start over
	and	al, 8+2
	out	dx, al
	jmp	.sa.start
.sa.2:	and	al, 2
	jz	.sa.1
	;ack it
	;beware! all bits in al are cleared, so if some packet arrived,
	;some problems will popup! (don't forget: this program is a hack)
	out	dx, al
	;send_ack end
	;call	wait_packet
	;wait_packet begin
.wp.1:	;mov	dx, BASE_ADDR+7  ;at this point dx=BASE_ADDR+7
	;no error check
	in	al, dx
	test	al, 1
	jz	.wp.1
	;wait_packet end
	;call	get_packet
	;get_packet begin
	mov	si, get_packet_data
	call	do_outs
        ;read it
	push	es
	push	ds
	pop	es
	mov	di, buffer-4
        mov    dx, BASE_ADDR+10h
	;the choice of 1600 is arbitrary
	mov	cx, 1600/2
        rep insw
	pop	es
        ;ack dma
        mov    dx, BASE_ADDR+7
        mov    al, 40h
        out    dx, al
	;update boundary (= current-1 modulo XX)
	mov	al, [buffer-4+1]
	mov	[curr_read], al
        dec    al
        cmp    al, 40h+12-1
        jne    .gp.2
        mov    al, 80h-1
.gp.2:  mov    dx, BASE_ADDR+3
        out    dx, al
	;if we received more than 1 packet, bad things will happen...
	;we should check 'current' (hack I said)
        ;ack the int
        mov    dx, BASE_ADDR+7
        mov    al, [buffer-4]
        out    dx, al
	;we can only receive UDP packet with payload of 1 byte or 1024 bytes
	;to know if last packet, simply check the upper 8 bits of its length
	popa
	cmp	byte [buffer_size+1], 0
	;get_packet end
	jnz	.2
	stc
	jmp	.over
.2:	rep movsb
	clc
.over:	pop	cx
	;pop	si
	ret

;section .data
block_count db 0
